require "import"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"

local substitutionTable = {
    ["chino"] = "Jieshuo"
}

function hasInternetConnection()
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
    local networkInfo = connectivityManager.getActiveNetworkInfo()
    return networkInfo ~= nil and networkInfo.isConnected()
end

function kill()
    speechRecognizer.destroy()
    speechRecognizer = nil
    return true
end

function startListening()
    if not hasInternetConnection() then
        service.asyncSpeak("இணைய இணைப்பு இல்லை.இணைய இணைப்பை சரிபார்த்து மீண்டும் முயலவும்.")
        return false
    end

    local verbalizationDetected = false

    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

    speechListener = RecognitionListener{
        onResults = function(results)
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                -- Se ha detectado alguna verbalización
                verbalizationDetected = true
                local recognizedText = data.get(0)

                -- Insert space before recognized text if there are characters in the text box
                local node = service.getEditText()
                local editText = service.getText(node)

                if editText and string.len(editText) > 0 then
                    recognizedText = " " .. recognizedText
                end

                recognizedText = string.gsub(recognizedText, "(%s?)நியூ லைன்(%s?)([%p]*)$", "%2\n%3")
                recognizedText = string.gsub(recognizedText, "(%s?)ஆச்சரியக்குறி(%s?)([%p]*)$", "%2!%3")
                recognizedText = string.gsub(recognizedText, "(%s?)கமா(%s?)([%p]*)$", "%2,%3")
recognizedText = string.gsub(recognizedText, "(%s?)கமா நியூ லைன்(%s?)([%p]*)$", "%2,\n%3")
                recognizedText = string.gsub(recognizedText, "(%s?)முற்றுப்புள்ளி(%s?)([%p]*)$", "%2.\n%3")
                recognizedText = string.gsub(recognizedText, "(%s?)கேள்விக்குறி(%s?)([%p]*)$", "%2?")

                service.insertText(node, recognizedText)
                service.speak(recognizedText)
            end
            -- Si no se detectó ninguna verbalización en el primer intento, detener reconocimiento de voz
            if not verbalizationDetected then
                kill()
                return false
            end
        end,
        onError = function()
            -- Ocurrió un error, detener reconocimiento de voz
            kill()
            return false
        end
    }

    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta_IN")
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    speechRecognizer.startListening(recognizerIntent)
    speechRecognizer.setRecognitionListener(speechListener)

    return true
end

startListening()
return true